



<!DOCTYPE html>
<html lang="en" class="no-js">
  <head>
    
      <meta charset="utf-8">
      <meta name="viewport" content="width=device-width,initial-scale=1">
      <meta http-equiv="x-ua-compatible" content="ie=edge">
      
        <meta name="description" content="我的技术笔记本~">
      
      
      
        <meta name="author" content="chenyuan">
      
      
        <meta name="lang:clipboard.copy" content="Copy to clipboard">
      
        <meta name="lang:clipboard.copied" content="Copied to clipboard">
      
        <meta name="lang:search.language" content="en">
      
        <meta name="lang:search.result.none" content="No matching documents">
      
        <meta name="lang:search.result.one" content="1 matching document">
      
        <meta name="lang:search.result.other" content="# matching documents">
      
        <meta name="lang:search.tokenizer" content="[\s\-]+">
      
      <link rel="shortcut icon" href="../assets/images/favicon.png">
      <meta name="generator" content="mkdocs-0.17.2, mkdocs-material-2.5.3">
    
    
      
        <title>Git - notebook</title>
      
    
    
      <link rel="stylesheet" href="../assets/stylesheets/application.aa3de92b.css">
      
    
    
      <script src="../assets/javascripts/modernizr.1aa3b519.js"></script>
    
    
      
        <link rel="stylesheet" href="https://fonts.loli.net/css?family=Roboto:300,400,400i,700|Roboto+Mono">
        <style>body,input{font-family:"Roboto","Helvetica Neue",Helvetica,Arial,sans-serif}code,kbd,pre{font-family:"Roboto Mono","Courier New",Courier,monospace}</style>
      
      <link rel="stylesheet" href="https://fonts.loli.net/icon?family=Material+Icons">
    
    
    
  </head>
  
  
    <body dir="ltr">
  
    <svg class="md-svg">
      <defs>
        
        
          <svg xmlns="http://www.w3.org/2000/svg" width="416" height="448" viewBox="0 0 416 448" id="github"><path fill="currentColor" d="M160 304q0 10-3.125 20.5t-10.75 19T128 352t-18.125-8.5-10.75-19T96 304t3.125-20.5 10.75-19T128 256t18.125 8.5 10.75 19T160 304zm160 0q0 10-3.125 20.5t-10.75 19T288 352t-18.125-8.5-10.75-19T256 304t3.125-20.5 10.75-19T288 256t18.125 8.5 10.75 19T320 304zm40 0q0-30-17.25-51T296 232q-10.25 0-48.75 5.25Q229.5 240 208 240t-39.25-2.75Q130.75 232 120 232q-29.5 0-46.75 21T56 304q0 22 8 38.375t20.25 25.75 30.5 15 35 7.375 37.25 1.75h42q20.5 0 37.25-1.75t35-7.375 30.5-15 20.25-25.75T360 304zm56-44q0 51.75-15.25 82.75-9.5 19.25-26.375 33.25t-35.25 21.5-42.5 11.875-42.875 5.5T212 416q-19.5 0-35.5-.75t-36.875-3.125-38.125-7.5-34.25-12.875T37 371.5t-21.5-28.75Q0 312 0 260q0-59.25 34-99-6.75-20.5-6.75-42.5 0-29 12.75-54.5 27 0 47.5 9.875t47.25 30.875Q171.5 96 212 96q37 0 70 8 26.25-20.5 46.75-30.25T376 64q12.75 25.5 12.75 54.5 0 21.75-6.75 42 34 40 34 99.5z"/></svg>
        
      </defs>
    </svg>
    <input class="md-toggle" data-md-toggle="drawer" type="checkbox" id="drawer">
    <input class="md-toggle" data-md-toggle="search" type="checkbox" id="search">
    <label class="md-overlay" data-md-component="overlay" for="drawer"></label>
    
      <a href="#git" tabindex="1" class="md-skip">
        Skip to content
      </a>
    
    
      <header class="md-header" data-md-component="header">
  <nav class="md-header-nav md-grid">
    <div class="md-flex">
      <div class="md-flex__cell md-flex__cell--shrink">
        <a href="../README/" title="notebook" class="md-header-nav__button md-logo">
          
            <i class="md-icon"></i>
          
        </a>
      </div>
      <div class="md-flex__cell md-flex__cell--shrink">
        <label class="md-icon md-icon--menu md-header-nav__button" for="drawer"></label>
      </div>
      <div class="md-flex__cell md-flex__cell--stretch">
        <div class="md-flex__ellipsis md-header-nav__title" data-md-component="title">
          
            
              <span class="md-header-nav__topic">
                notebook
              </span>
              <span class="md-header-nav__topic">
                Git
              </span>
            
          
        </div>
      </div>
      <div class="md-flex__cell md-flex__cell--shrink">
        
          
            <label class="md-icon md-icon--search md-header-nav__button" for="search"></label>
            
<div class="md-search" data-md-component="search" role="dialog">
  <label class="md-search__overlay" for="search"></label>
  <div class="md-search__inner" role="search">
    <form class="md-search__form" name="search">
      <input type="text" class="md-search__input" name="query" placeholder="Search" autocapitalize="off" autocorrect="off" autocomplete="off" spellcheck="false" data-md-component="query" data-md-state="active">
      <label class="md-icon md-search__icon" for="search"></label>
      <button type="reset" class="md-icon md-search__icon" data-md-component="reset" tabindex="-1">
        &#xE5CD;
      </button>
    </form>
    <div class="md-search__output">
      <div class="md-search__scrollwrap" data-md-scrollfix>
        <div class="md-search-result" data-md-component="result">
          <div class="md-search-result__meta">
            Type to start searching
          </div>
          <ol class="md-search-result__list"></ol>
        </div>
      </div>
    </div>
  </div>
</div>
          
        
      </div>
      
        <div class="md-flex__cell md-flex__cell--shrink">
          <div class="md-header-nav__source">
            


  


  <a href="https://github.com/zjuchenyuan/notebook/" title="Go to repository" class="md-source" data-md-source="github">
    
      <div class="md-source__icon">
        <svg viewBox="0 0 24 24" width="24" height="24">
          <use xlink:href="#github" width="24" height="24"></use>
        </svg>
      </div>
    
    <div class="md-source__repository">
      GitHub
    </div>
  </a>

          </div>
        </div>
      
    </div>
  </nav>
</header>
    
    <div class="md-container">
      
        
      
      
      <main class="md-main">
        <div class="md-main__inner md-grid" data-md-component="container">
          
            
              <div class="md-sidebar md-sidebar--primary" data-md-component="navigation">
                <div class="md-sidebar__scrollwrap">
                  <div class="md-sidebar__inner">
                    <nav class="md-nav md-nav--primary" data-md-level="0">
  <label class="md-nav__title md-nav__title--site" for="drawer">
    <span class="md-nav__button md-logo">
      
        <i class="md-icon"></i>
      
    </span>
    notebook
  </label>
  
    <div class="md-nav__source">
      


  


  <a href="https://github.com/zjuchenyuan/notebook/" title="Go to repository" class="md-source" data-md-source="github">
    
      <div class="md-source__icon">
        <svg viewBox="0 0 24 24" width="24" height="24">
          <use xlink:href="#github" width="24" height="24"></use>
        </svg>
      </div>
    
    <div class="md-source__repository">
      GitHub
    </div>
  </a>

    </div>
  
  <ul class="md-nav__list" data-md-scrollfix>
    
      
      
      


  <li class="md-nav__item">
    <a href="../README/" title="Home" class="md-nav__link">
      Home
    </a>
  </li>

    
      
      
      


  <li class="md-nav__item md-nav__item--nested">
    
      <input class="md-toggle md-nav__toggle" data-md-toggle="nav-2" type="checkbox" id="nav-2">
    
    <label class="md-nav__link" for="nav-2">
      Python
    </label>
    <nav class="md-nav" data-md-component="collapsible" data-md-level="1">
      <label class="md-nav__title" for="nav-2">
        Python
      </label>
      <ul class="md-nav__list" data-md-scrollfix>
        
        
          
          
          


  <li class="md-nav__item">
    <a href="../Python/" title="Python" class="md-nav__link">
      Python
    </a>
  </li>

        
          
          
          


  <li class="md-nav__item">
    <a href="../gist/" title="Gist Python一些常用代码片段" class="md-nav__link">
      Gist Python一些常用代码片段
    </a>
  </li>

        
      </ul>
    </nav>
  </li>

    
      
      
      


  <li class="md-nav__item md-nav__item--nested">
    
      <input class="md-toggle md-nav__toggle" data-md-toggle="nav-3" type="checkbox" id="nav-3">
    
    <label class="md-nav__link" for="nav-3">
      Programming Languages
    </label>
    <nav class="md-nav" data-md-component="collapsible" data-md-level="1">
      <label class="md-nav__title" for="nav-3">
        Programming Languages
      </label>
      <ul class="md-nav__list" data-md-scrollfix>
        
        
          
          
          


  <li class="md-nav__item">
    <a href="../BASH/" title="BASH" class="md-nav__link">
      BASH
    </a>
  </li>

        
          
          
          


  <li class="md-nav__item">
    <a href="../BAT/" title="BAT批处理" class="md-nav__link">
      BAT批处理
    </a>
  </li>

        
          
          
          


  <li class="md-nav__item">
    <a href="../C/" title="C语言" class="md-nav__link">
      C语言
    </a>
  </li>

        
          
          
          


  <li class="md-nav__item md-nav__item--nested">
    
      <input class="md-toggle md-nav__toggle" data-md-toggle="nav-3-4" type="checkbox" id="nav-3-4">
    
    <label class="md-nav__link" for="nav-3-4">
      Java
    </label>
    <nav class="md-nav" data-md-component="collapsible" data-md-level="2">
      <label class="md-nav__title" for="nav-3-4">
        Java
      </label>
      <ul class="md-nav__list" data-md-scrollfix>
        
        
          
          
          


  <li class="md-nav__item">
    <a href="../Java/" title="Java" class="md-nav__link">
      Java
    </a>
  </li>

        
          
          
          


  <li class="md-nav__item">
    <a href="../S2-045/" title="S2-045" class="md-nav__link">
      S2-045
    </a>
  </li>

        
      </ul>
    </nav>
  </li>

        
          
          
          


  <li class="md-nav__item">
    <a href="../JavaScript/" title="JavaScript" class="md-nav__link">
      JavaScript
    </a>
  </li>

        
          
          
          


  <li class="md-nav__item">
    <a href="../PHP/" title="PHP" class="md-nav__link">
      PHP
    </a>
  </li>

        
      </ul>
    </nav>
  </li>

    
      
      
      


  <li class="md-nav__item md-nav__item--nested">
    
      <input class="md-toggle md-nav__toggle" data-md-toggle="nav-4" type="checkbox" id="nav-4">
    
    <label class="md-nav__link" for="nav-4">
      Web
    </label>
    <nav class="md-nav" data-md-component="collapsible" data-md-level="1">
      <label class="md-nav__title" for="nav-4">
        Web
      </label>
      <ul class="md-nav__list" data-md-scrollfix>
        
        
          
          
          


  <li class="md-nav__item">
    <a href="../CDN/" title="CDN" class="md-nav__link">
      CDN
    </a>
  </li>

        
          
          
          


  <li class="md-nav__item">
    <a href="../cURL/" title="cURL" class="md-nav__link">
      cURL
    </a>
  </li>

        
          
          
          


  <li class="md-nav__item md-nav__item--nested">
    
      <input class="md-toggle md-nav__toggle" data-md-toggle="nav-4-3" type="checkbox" id="nav-4-3">
    
    <label class="md-nav__link" for="nav-4-3">
      Favorites
    </label>
    <nav class="md-nav" data-md-component="collapsible" data-md-level="2">
      <label class="md-nav__title" for="nav-4-3">
        Favorites
      </label>
      <ul class="md-nav__list" data-md-scrollfix>
        
        
          
          
          


  <li class="md-nav__item">
    <a href="../Favorites/" title="Favorites" class="md-nav__link">
      Favorites
    </a>
  </li>

        
          
          
          


  <li class="md-nav__item">
    <a href="../GithubProjectRecommendation/" title="Github Project Recommendation" class="md-nav__link">
      Github Project Recommendation
    </a>
  </li>

        
          
          
          


  <li class="md-nav__item">
    <a href="../Links/" title="更多链接" class="md-nav__link">
      更多链接
    </a>
  </li>

        
      </ul>
    </nav>
  </li>

        
          
          
          


  <li class="md-nav__item">
    <a href="../Flask/" title="Flask" class="md-nav__link">
      Flask
    </a>
  </li>

        
          
          
          


  <li class="md-nav__item">
    <a href="../MySQL/" title="MySQL" class="md-nav__link">
      MySQL
    </a>
  </li>

        
          
          
          


  <li class="md-nav__item">
    <a href="../Nginx/" title="Nginx" class="md-nav__link">
      Nginx
    </a>
  </li>

        
          
          
          


  <li class="md-nav__item">
    <a href="../RabbitMQ/" title="RabbitMQ" class="md-nav__link">
      RabbitMQ
    </a>
  </li>

        
      </ul>
    </nav>
  </li>

    
      
      
      

  


  <li class="md-nav__item md-nav__item--active md-nav__item--nested">
    
      <input class="md-toggle md-nav__toggle" data-md-toggle="nav-5" type="checkbox" id="nav-5" checked>
    
    <label class="md-nav__link" for="nav-5">
      Development
    </label>
    <nav class="md-nav" data-md-component="collapsible" data-md-level="1">
      <label class="md-nav__title" for="nav-5">
        Development
      </label>
      <ul class="md-nav__list" data-md-scrollfix>
        
        
          
          
          


  <li class="md-nav__item">
    <a href="../Developer/" title="Developer" class="md-nav__link">
      Developer
    </a>
  </li>

        
          
          
          


  <li class="md-nav__item">
    <a href="../Docker/" title="Docker" class="md-nav__link">
      Docker
    </a>
  </li>

        
          
          
          

  


  <li class="md-nav__item md-nav__item--active">
    
    <input class="md-toggle md-nav__toggle" data-md-toggle="toc" type="checkbox" id="toc">
    
      
    
    
      <label class="md-nav__link md-nav__link--active" for="toc">
        Git
      </label>
    
    <a href="./" title="Git" class="md-nav__link md-nav__link--active">
      Git
    </a>
    
      
<nav class="md-nav md-nav--secondary">
  
  
    
  
  
    <label class="md-nav__title" for="toc">Table of contents</label>
    <ul class="md-nav__list" data-md-scrollfix>
      
        <li class="md-nav__item">
  <a href="#_1" title="立即使用" class="md-nav__link">
    立即使用
  </a>
  
</li>
      
        <li class="md-nav__item">
  <a href="#git-clone" title="加速git clone" class="md-nav__link">
    加速git clone
  </a>
  
</li>
      
        <li class="md-nav__item">
  <a href="#git-push" title="git push加速" class="md-nav__link">
    git push加速
  </a>
  
</li>
      
        <li class="md-nav__item">
  <a href="#git-push_1" title="git push免密码" class="md-nav__link">
    git push免密码
  </a>
  
</li>
      
        <li class="md-nav__item">
  <a href="#bash" title="bash别名设置" class="md-nav__link">
    bash别名设置
  </a>
  
</li>
      
        <li class="md-nav__item">
  <a href="#bashdirty" title="设置bash中的自动完成与dirty提示" class="md-nav__link">
    设置bash中的自动完成与dirty提示
  </a>
  
</li>
      
        <li class="md-nav__item">
  <a href="#_2" title="好玩的命令们" class="md-nav__link">
    好玩的命令们
  </a>
  
    <nav class="md-nav">
      <ul class="md-nav__list">
        
          <li class="md-nav__item">
  <a href="#git-status" title="git status" class="md-nav__link">
    git status
  </a>
  
</li>
        
          <li class="md-nav__item">
  <a href="#git-reset" title="git reset" class="md-nav__link">
    git reset
  </a>
  
</li>
        
          <li class="md-nav__item">
  <a href="#git-checkout" title="git checkout" class="md-nav__link">
    git checkout
  </a>
  
</li>
        
          <li class="md-nav__item">
  <a href="#git-reset-soft" title="git reset --soft " class="md-nav__link">
    git reset --soft 
  </a>
  
</li>
        
          <li class="md-nav__item">
  <a href="#git-reset-hard" title="恢复git reset --hard删除的文件" class="md-nav__link">
    恢复git reset --hard删除的文件
  </a>
  
</li>
        
      </ul>
    </nav>
  
</li>
      
        <li class="md-nav__item">
  <a href="#_3" title="你可能会问的一些问题" class="md-nav__link">
    你可能会问的一些问题
  </a>
  
</li>
      
        <li class="md-nav__item">
  <a href="#git_1" title="Git各种情景" class="md-nav__link">
    Git各种情景
  </a>
  
    <nav class="md-nav">
      <ul class="md-nav__list">
        
          <li class="md-nav__item">
  <a href="#aliba" title="忽略*.a文件但不想忽略lib.a" class="md-nav__link">
    忽略*.a文件但不想忽略lib.a
  </a>
  
</li>
        
          <li class="md-nav__item">
  <a href="#commit" title="commit补上忘掉的文件" class="md-nav__link">
    commit补上忘掉的文件
  </a>
  
</li>
        
          <li class="md-nav__item">
  <a href="#_4" title="查出此行代码的最后修改者" class="md-nav__link">
    查出此行代码的最后修改者
  </a>
  
</li>
        
          <li class="md-nav__item">
  <a href="#commit_1" title="文件一次性改太多了，拆成多次commit" class="md-nav__link">
    文件一次性改太多了，拆成多次commit
  </a>
  
</li>
        
          <li class="md-nav__item">
  <a href="#_5" title="本地忽略一些个人的修改" class="md-nav__link">
    本地忽略一些个人的修改
  </a>
  
</li>
        
          <li class="md-nav__item">
  <a href="#branchpushgit-push-u" title="本地创建branch后push操作git push -u" class="md-nav__link">
    本地创建branch后push操作git push -u
  </a>
  
</li>
        
      </ul>
    </nav>
  
</li>
      
        <li class="md-nav__item">
  <a href="#gpggit" title="用gpg给git提交签名" class="md-nav__link">
    用gpg给git提交签名
  </a>
  
    <nav class="md-nav">
      <ul class="md-nav__list">
        
          <li class="md-nav__item">
  <a href="#gpg2" title="安装gpg2" class="md-nav__link">
    安装gpg2
  </a>
  
</li>
        
          <li class="md-nav__item">
  <a href="#key" title="创建一个新的key" class="md-nav__link">
    创建一个新的key
  </a>
  
</li>
        
          <li class="md-nav__item">
  <a href="#key-github" title="导出key的公钥 在github设置中提交" class="md-nav__link">
    导出key的公钥 在github设置中提交
  </a>
  
</li>
        
          <li class="md-nav__item">
  <a href="#gitgpg" title="配置git使用gpg签名" class="md-nav__link">
    配置git使用gpg签名
  </a>
  
</li>
        
          <li class="md-nav__item">
  <a href="#gpg" title="修改gpg要求再次输入密码的时间限制" class="md-nav__link">
    修改gpg要求再次输入密码的时间限制
  </a>
  
</li>
        
      </ul>
    </nav>
  
</li>
      
      
      
    </ul>
  
</nav>
    
  </li>

        
          
          
          


  <li class="md-nav__item">
    <a href="../Jekyll/" title="Jekyll" class="md-nav__link">
      Jekyll
    </a>
  </li>

        
          
          
          


  <li class="md-nav__item">
    <a href="../WindowsSoftware/" title="WindowsSoftware" class="md-nav__link">
      WindowsSoftware
    </a>
  </li>

        
      </ul>
    </nav>
  </li>

    
      
      
      


  <li class="md-nav__item md-nav__item--nested">
    
      <input class="md-toggle md-nav__toggle" data-md-toggle="nav-6" type="checkbox" id="nav-6">
    
    <label class="md-nav__link" for="nav-6">
      Linux
    </label>
    <nav class="md-nav" data-md-component="collapsible" data-md-level="1">
      <label class="md-nav__title" for="nav-6">
        Linux
      </label>
      <ul class="md-nav__list" data-md-scrollfix>
        
        
          
          
          


  <li class="md-nav__item">
    <a href="../Linux-backup/" title="Linux-backup" class="md-nav__link">
      Linux-backup
    </a>
  </li>

        
          
          
          


  <li class="md-nav__item">
    <a href="../Linux-setup/" title="Linux-setup" class="md-nav__link">
      Linux-setup
    </a>
  </li>

        
          
          
          


  <li class="md-nav__item">
    <a href="../Linux-SSH/" title="Linux-SSH" class="md-nav__link">
      Linux-SSH
    </a>
  </li>

        
          
          
          


  <li class="md-nav__item">
    <a href="../Linux-cli/" title="Linux-cli" class="md-nav__link">
      Linux-cli
    </a>
  </li>

        
          
          
          


  <li class="md-nav__item">
    <a href="../Linux-VirtualBox/" title="Linux-VirtualBox" class="md-nav__link">
      Linux-VirtualBox
    </a>
  </li>

        
          
          
          


  <li class="md-nav__item">
    <a href="../Ubuntu/" title="Ubuntu" class="md-nav__link">
      Ubuntu
    </a>
  </li>

        
      </ul>
    </nav>
  </li>

    
      
      
      


  <li class="md-nav__item md-nav__item--nested">
    
      <input class="md-toggle md-nav__toggle" data-md-toggle="nav-7" type="checkbox" id="nav-7">
    
    <label class="md-nav__link" for="nav-7">
      My Projects
    </label>
    <nav class="md-nav" data-md-component="collapsible" data-md-level="1">
      <label class="md-nav__title" for="nav-7">
        My Projects
      </label>
      <ul class="md-nav__list" data-md-scrollfix>
        
        
          
          
          


  <li class="md-nav__item">
    <a href="../zjugrshelper/" title="ZJU grs helper" class="md-nav__link">
      ZJU grs helper
    </a>
  </li>

        
      </ul>
    </nav>
  </li>

    
  </ul>
</nav>
                  </div>
                </div>
              </div>
            
            
              <div class="md-sidebar md-sidebar--secondary" data-md-component="toc">
                <div class="md-sidebar__scrollwrap">
                  <div class="md-sidebar__inner">
                    
<nav class="md-nav md-nav--secondary">
  
  
    
  
  
    <label class="md-nav__title" for="toc">Table of contents</label>
    <ul class="md-nav__list" data-md-scrollfix>
      
        <li class="md-nav__item">
  <a href="#_1" title="立即使用" class="md-nav__link">
    立即使用
  </a>
  
</li>
      
        <li class="md-nav__item">
  <a href="#git-clone" title="加速git clone" class="md-nav__link">
    加速git clone
  </a>
  
</li>
      
        <li class="md-nav__item">
  <a href="#git-push" title="git push加速" class="md-nav__link">
    git push加速
  </a>
  
</li>
      
        <li class="md-nav__item">
  <a href="#git-push_1" title="git push免密码" class="md-nav__link">
    git push免密码
  </a>
  
</li>
      
        <li class="md-nav__item">
  <a href="#bash" title="bash别名设置" class="md-nav__link">
    bash别名设置
  </a>
  
</li>
      
        <li class="md-nav__item">
  <a href="#bashdirty" title="设置bash中的自动完成与dirty提示" class="md-nav__link">
    设置bash中的自动完成与dirty提示
  </a>
  
</li>
      
        <li class="md-nav__item">
  <a href="#_2" title="好玩的命令们" class="md-nav__link">
    好玩的命令们
  </a>
  
    <nav class="md-nav">
      <ul class="md-nav__list">
        
          <li class="md-nav__item">
  <a href="#git-status" title="git status" class="md-nav__link">
    git status
  </a>
  
</li>
        
          <li class="md-nav__item">
  <a href="#git-reset" title="git reset" class="md-nav__link">
    git reset
  </a>
  
</li>
        
          <li class="md-nav__item">
  <a href="#git-checkout" title="git checkout" class="md-nav__link">
    git checkout
  </a>
  
</li>
        
          <li class="md-nav__item">
  <a href="#git-reset-soft" title="git reset --soft " class="md-nav__link">
    git reset --soft 
  </a>
  
</li>
        
          <li class="md-nav__item">
  <a href="#git-reset-hard" title="恢复git reset --hard删除的文件" class="md-nav__link">
    恢复git reset --hard删除的文件
  </a>
  
</li>
        
      </ul>
    </nav>
  
</li>
      
        <li class="md-nav__item">
  <a href="#_3" title="你可能会问的一些问题" class="md-nav__link">
    你可能会问的一些问题
  </a>
  
</li>
      
        <li class="md-nav__item">
  <a href="#git_1" title="Git各种情景" class="md-nav__link">
    Git各种情景
  </a>
  
    <nav class="md-nav">
      <ul class="md-nav__list">
        
          <li class="md-nav__item">
  <a href="#aliba" title="忽略*.a文件但不想忽略lib.a" class="md-nav__link">
    忽略*.a文件但不想忽略lib.a
  </a>
  
</li>
        
          <li class="md-nav__item">
  <a href="#commit" title="commit补上忘掉的文件" class="md-nav__link">
    commit补上忘掉的文件
  </a>
  
</li>
        
          <li class="md-nav__item">
  <a href="#_4" title="查出此行代码的最后修改者" class="md-nav__link">
    查出此行代码的最后修改者
  </a>
  
</li>
        
          <li class="md-nav__item">
  <a href="#commit_1" title="文件一次性改太多了，拆成多次commit" class="md-nav__link">
    文件一次性改太多了，拆成多次commit
  </a>
  
</li>
        
          <li class="md-nav__item">
  <a href="#_5" title="本地忽略一些个人的修改" class="md-nav__link">
    本地忽略一些个人的修改
  </a>
  
</li>
        
          <li class="md-nav__item">
  <a href="#branchpushgit-push-u" title="本地创建branch后push操作git push -u" class="md-nav__link">
    本地创建branch后push操作git push -u
  </a>
  
</li>
        
      </ul>
    </nav>
  
</li>
      
        <li class="md-nav__item">
  <a href="#gpggit" title="用gpg给git提交签名" class="md-nav__link">
    用gpg给git提交签名
  </a>
  
    <nav class="md-nav">
      <ul class="md-nav__list">
        
          <li class="md-nav__item">
  <a href="#gpg2" title="安装gpg2" class="md-nav__link">
    安装gpg2
  </a>
  
</li>
        
          <li class="md-nav__item">
  <a href="#key" title="创建一个新的key" class="md-nav__link">
    创建一个新的key
  </a>
  
</li>
        
          <li class="md-nav__item">
  <a href="#key-github" title="导出key的公钥 在github设置中提交" class="md-nav__link">
    导出key的公钥 在github设置中提交
  </a>
  
</li>
        
          <li class="md-nav__item">
  <a href="#gitgpg" title="配置git使用gpg签名" class="md-nav__link">
    配置git使用gpg签名
  </a>
  
</li>
        
          <li class="md-nav__item">
  <a href="#gpg" title="修改gpg要求再次输入密码的时间限制" class="md-nav__link">
    修改gpg要求再次输入密码的时间限制
  </a>
  
</li>
        
      </ul>
    </nav>
  
</li>
      
      
      
    </ul>
  
</nav>
                  </div>
                </div>
              </div>
            
          
          <div class="md-content">
            <article class="md-content__inner md-typeset">
              
                
                  <a href="https://github.com/zjuchenyuan/notebook/edit/master/Git.md" title="Edit this page" class="md-icon md-content__icon">&#xE3C9;</a>
                
                
                <h1 id="git">Git的学习笔记咯<a class="headerlink" href="#git" title="Permanent link">&para;</a></h1>
<blockquote>
<p>参考 <strong>沉浸式学 Git</strong> <a href="http://igit.linuxtoy.org/">http://igit.linuxtoy.org/</a></p>
</blockquote>
<hr />
<h2 id="_1">立即使用<a class="headerlink" href="#_1" title="Permanent link">&para;</a></h2>
<p>在网页上先创建了仓库，设置好.gitignore</p>
<div class="codehilite"><pre><span></span>git clone  github提供的地址<span class="o">(</span>用ssh的<span class="o">)</span>
<span class="c1"># 现在创建了你的仓库文件夹，将需要上传的文件放进去</span>
<span class="nb">cd</span> 你的仓库名称
git add .
git commit -a -m <span class="s2">&quot;这次改了些啥？&quot;</span>
git push
</pre></div>


<hr />
<h2 id="git-clone">加速git clone<a class="headerlink" href="#git-clone" title="Permanent link">&para;</a></h2>
<p>方法1：配置一个代理(如privoxy)，并使用https地址</p>
<p>方法2：使用<code>--depth 1</code>参数表示不要复制历史</p>
<div class="codehilite"><pre><span></span>export https_proxy=&quot;http://127.0.0.1:8118&quot;
git clone --depth 1 https://github.com/zjuchenyuan/notebook
</pre></div>


<hr />
<h2 id="git-push">git push加速<a class="headerlink" href="#git-push" title="Permanent link">&para;</a></h2>
<p>代码参见<a href="../code/ssgit.txt">code/ssgit.txt</a></p>
<hr />
<h2 id="git-push_1">git push免密码<a class="headerlink" href="#git-push_1" title="Permanent link">&para;</a></h2>
<p><a href="http://参照http://blog.csdn.net">参照http://blog.csdn.net</a>/chfe007/article/details/43388041</p>
<p>首先生成自己的ssh密钥，不要修改生成的文件位置</p>
<div class="codehilite"><pre><span></span>ssh-keygen -t rsa -b 4096
</pre></div>


<p>然后把<code>~/.ssh/id_rsa.pub</code>的内容设置到github中，<a href="https://github.com/settings/keys">网页端操作</a>；建议顺带启用两步验证</p>
<p>新手还告诉git自己是谁：</p>
<div class="codehilite"><pre><span></span>git config --global user.email &quot;你的邮箱&quot;
git config --global user.name &quot;你的用户名&quot;
</pre></div>


<p>如果当前仓库是https的，改为git方式：</p>
<div class="codehilite"><pre><span></span>git remote set-url origin git@github.com:用户名/仓库名称.git
</pre></div>


<hr />
<h2 id="bash">bash别名设置<a class="headerlink" href="#bash" title="Permanent link">&para;</a></h2>
<p>通过修改~/.bashrc来设置别名，让git的日常使用更简单：</p>
<div class="codehilite"><pre><span></span>func_g(){
  git add .
  git commit -a -m &quot;$1&quot;
  git push
}
alias g=func_g
alias gs=&#39;git status &#39;
alias ga=&#39;git add &#39;
alias gb=&#39;git branch &#39;
alias gc=&#39;git commit&#39;
alias gd=&#39;git diff&#39;
alias go=&#39;git checkout &#39;
alias gp=&#39;git push&#39;
alias gl=&quot;git log --all --pretty=format:&#39;%h %ad | %s%d [%an]&#39; --graph --date=short&quot;
</pre></div>


<p><img alt="gl的效果" src="https://raw.githubusercontent.com/zjuchenyuan/notebook/master/download/img/gl.jpg" /></p>
<p>完成一次提交，现在只需要<code>g "提交信息"</code></p>
<p>要立即生效，可以执行<code>source ~/.bashrc</code></p>
<h2 id="bashdirty">设置bash中的自动完成与dirty提示<a class="headerlink" href="#bashdirty" title="Permanent link">&para;</a></h2>
<p>此部分内容来自Udacity 如何使用 Git 和 GitHub 课程</p>
<p>下载需要的文件</p>
<div class="codehilite"><pre><span></span>curl -O https://raw.githubusercontent.com/git/git/master/contrib/completion/git-completion.bash
curl -O https://raw.githubusercontent.com/git/git/master/contrib/completion/git-prompt.sh
</pre></div>


<p>在<code>~/.bashrc</code>末尾添加：</p>
<div class="codehilite"><pre><span></span>source ~/git-completion.bash
green=&quot;\[\033[0;32m\]&quot;
blue=&quot;\[\033[0;34m\]&quot;
purple=&quot;\[\033[0;35m\]&quot;
reset=&quot;\[\033[0m\]&quot;
source ~/git-prompt.sh
export GIT_PS1_SHOWDIRTYSTATE=1
export PS1=&quot;$purple\u$green\$(__git_ps1) \w\a $ $reset&quot;
</pre></div>


<p>效果如图，如果出现了未提交的修改，会自动显示出*表示dirty：</p>
<p><img alt="setgit.jpg" src="../download/img/setgit.jpg" /></p>
<h2 id="_2">好玩的命令们<a class="headerlink" href="#_2" title="Permanent link">&para;</a></h2>
<h3 id="git-status">git status<a class="headerlink" href="#git-status" title="Permanent link">&para;</a></h3>
<p>查看状态咯~</p>
<h3 id="git-reset">git reset<a class="headerlink" href="#git-reset" title="Permanent link">&para;</a></h3>
<p>已经<code>git add</code>了，想取消这一步就用<code>git reset</code></p>
<h3 id="git-checkout">git checkout<a class="headerlink" href="#git-checkout" title="Permanent link">&para;</a></h3>
<p>啊。。。代码搞坏了我要回滚到上次commit，用<code>git checkout -- 文件名</code></p>
<h3 id="git-reset-soft">git reset &ndash;soft <commit_id><a class="headerlink" href="#git-reset-soft" title="Permanent link">&para;</a></h3>
<p>撤销到某次commit，但不删除新增文件</p>
<p>其中commit_id可以从<code>git log</code>获得</p>
<h3 id="git-reset-hard">恢复git reset &ndash;hard删除的文件<a class="headerlink" href="#git-reset-hard" title="Permanent link">&para;</a></h3>
<p>git的历史是不能用命令修改的，丢失的commit用reflog可以找回，除非git已经把它当成垃圾删除（30天）</p>
<div class="codehilite"><pre><span></span>git stash save
git reflog # 查看丢失的那个commit的id
git checkout 那个commitid
git branch recover # 创建recover分支
git checkout master # 回到master
git merge recover # 合并recover到master
git branch -d recover # 合并完成后就可以删了
</pre></div>


<hr />
<h2 id="_3">你可能会问的一些问题<a class="headerlink" href="#_3" title="Permanent link">&para;</a></h2>
<ul>
<li>为啥要<strong>git add</strong>呢?</li>
</ul>
<p>因为有些时候两个文件可能是不相关的修改，应该分别提交两次</p>
<blockquote>
<p>通过分开暂存和提交，你能够更加容易地调优每一个提交。</p>
</blockquote>
<ul>
<li>为啥不改.profile而是改.bashrc呢</li>
</ul>
<p>因为win10中只要有一个bash窗口没关掉，启动bash就不是登录，而是相当于再开了个<code>docker exec -i -t bashonwin10 /bin/bash</code></p>
<p>此时是不会执行登录脚本.profile的，但是.bashrc还是会执行的</p>
<hr />
<h2 id="git_1">Git各种情景<a class="headerlink" href="#git_1" title="Permanent link">&para;</a></h2>
<p>Learned from <a href="https://github.com/Gazler/githug">githug</a></p>
<h3 id="aliba">忽略*.a文件但不想忽略lib.a<a class="headerlink" href="#aliba" title="Permanent link">&para;</a></h3>
<p>文档查看：<code>git gitignore --help</code></p>
<p>!表示负向选择，在.gitignore中添加：</p>
<div class="codehilite"><pre><span></span>*.a
!lib.a
</pre></div>


<h3 id="commit">commit补上忘掉的文件<a class="headerlink" href="#commit" title="Permanent link">&para;</a></h3>
<p>如果发现上次commit漏了文件，不应该新加commit而是应该用amend，否则可能上CI就挂</p>
<div class="codehilite"><pre><span></span>git add forgotten.txt
git commit --amend
</pre></div>


<h3 id="_4">查出此行代码的最后修改者<a class="headerlink" href="#_4" title="Permanent link">&para;</a></h3>
<p>github提供的blame功能更好看，显示每行代码的作者和来源于哪次commit</p>
<div class="codehilite"><pre><span></span>git blame filename
</pre></div>


<h3 id="commit_1">文件一次性改太多了，拆成多次commit<a class="headerlink" href="#commit_1" title="Permanent link">&para;</a></h3>
<p>让每次commit保持在比较小的改动，不要在一个commit中出现两个不那么相关的修改</p>
<p>本知识学习自：<a href="http://www.oschina.net/translate/10-tips-git-next-level">10 个迅速提升你 Git 水平的提示</a></p>
<p>方法是在add的时候给出参数-p</p>
<p>然后git会在每一个修改的block询问是否加入这次的commit，回答y表示加入，n表示不加入，s表示进一步拆分这个block</p>
<p>完成好选择后，使用<code>git diff --staged</code>命令来查询暂存的修改，没有问题就可以继续<code>git commit</code>啦</p>
<h3 id="_5">本地忽略一些个人的修改<a class="headerlink" href="#_5" title="Permanent link">&para;</a></h3>
<p>原文： <a href="http://stackoverflow.com/questions/1753070/git-ignore-files-only-locally">http://stackoverflow.com/questions/1753070/git-ignore-files-only-locally</a></p>
<p>有时候我们不想让git追踪一些个人相关的文件，例如config中修改Debug=True，此时如果去修改.gitignore造成的影响是全局的，并且需要从git中删除这个文件；手动避开add config很烦，有没有更好的方法，让git忽略掉config文件的修改呢？</p>
<p>方法是修改<code>.git/info/exclude</code>文件，这个文件的语法规则与.gitignore一样</p>
<p>如果已经造成了修改，还需要执行以下命令：</p>
<div class="codehilite"><pre><span></span>git update-index --assume-unchanged [&lt;file&gt;...]
</pre></div>


<h3 id="branchpushgit-push-u">本地创建branch后push操作git push -u<a class="headerlink" href="#branchpushgit-push-u" title="Permanent link">&para;</a></h3>
<p>From: <a href="http://stackoverflow.com/questions/2765421/how-do-i-push-a-new-local-branch-to-a-remote-git-repository-and-track-it-too">http://stackoverflow.com/questions/2765421/how-do-i-push-a-new-local-branch-to-a-remote-git-repository-and-track-it-too</a></p>
<p>执行了一些修改引入新功能，但还不能工作，决定建立一个dev分支：</p>
<div class="codehilite"><pre><span></span>git checkout -b dev
</pre></div>


<p>现在再执行<code>git add</code>，<code>git commit</code>后，需要把新的分支push给远程服务器：</p>
<div class="codehilite"><pre><span></span>git push -u origin dev
</pre></div>


<hr />
<h2 id="gpggit">用gpg给git提交签名<a class="headerlink" href="#gpggit" title="Permanent link">&para;</a></h2>
<p><a href="http://参考：https://help.github.com">参考：https://help.github.com</a>/articles/signing-commits-with-gpg/</p>
<p>下述以ubuntu16.04（其实是bash on win10）讲解整个过程</p>
<h3 id="gpg2">安装gpg2<a class="headerlink" href="#gpg2" title="Permanent link">&para;</a></h3>
<p>查看gpg版本：<code>gpg --version</code>发现版本是<code>gpg (GnuPG) 1.4.20</code>，而教程要求要2以上，所以先要安装gpg2，并告诉git我们要使用gpg2：</p>
<div class="codehilite"><pre><span></span>apt install -y gpg2
git config --global gpg.program gpg2
</pre></div>


<h3 id="key">创建一个新的key<a class="headerlink" href="#key" title="Permanent link">&para;</a></h3>
<p>这里github给出的命令有问题，google发现参数改了</p>
<div class="codehilite"><pre><span></span>gpg2 --full-gen-key
</pre></div>


<p>回车选择RSA and RSA，然后输入密钥大小输入4096，然后回车永不过期，确认y，然后输入自己的名字和邮箱 注意这里邮箱要和git commit用到的邮箱一致</p>
<h3 id="key-github">导出key的公钥 在github设置中提交<a class="headerlink" href="#key-github" title="Permanent link">&para;</a></h3>
<div class="codehilite"><pre><span></span>gpg2 --list-secret-keys --keyid-format LONG
</pre></div>


<p>如下输出中，我们需要的是3AA5C34371567BD2这一串 就是sec那一行的4096R/后面的东西</p>
<div class="codehilite"><pre><span></span>$ gpg2 --list-secret-keys --keyid-format LONG
/Users/hubot/.gnupg/secring.gpg
------------------------------------
sec   4096R/3AA5C34371567BD2 <span class="m">2016</span>-03-10 <span class="o">[</span>expires: <span class="m">2017</span>-03-10<span class="o">]</span>
uid                          Hubot 
ssb   4096R/42B317FD4BA89E7A <span class="m">2016</span>-03-10
</pre></div>


<p>然后得到公钥：</p>
<div class="codehilite"><pre><span></span>gpg2 --armor --export 3AA5C34371567BD2
</pre></div>


<p>复制屏幕上输出的一大串，打开下面的网页 粘贴提交</p>
<p><a href="https://github.com/settings/gpg/new">https://github.com/settings/gpg/new</a></p>
<h3 id="gitgpg">配置git使用gpg签名<a class="headerlink" href="#gitgpg" title="Permanent link">&para;</a></h3>
<p>告诉git默认使用这个key：</p>
<div class="codehilite"><pre><span></span>git config --global user.signingkey 3AA5C34371567BD2
git config --global commit.gpgsign true
</pre></div>


<p>执行 建议将这一行写入~/.bashrc：</p>
<div class="codehilite"><pre><span></span>export GPG_TTY=$(tty)
</pre></div>


<p>然后就是正常的git add .，git commit -m &ldquo;message&rdquo;咯</p>
<p>gpg-agent会在后台运行，默认10分钟内不需要再次输入密码</p>
<h3 id="gpg">修改gpg要求再次输入密码的时间限制<a class="headerlink" href="#gpg" title="Permanent link">&para;</a></h3>
<p>10分钟的默认限制还是太短了，对于安全性要求不高的情景（比如自己的开源代码push到github），不妨设置为密码一直有效，直到gpg-agent重启</p>
<p>下面的设置将限制改到1年，当然gpg-agent重启还是要再次输入密码的：</p>
<div class="codehilite"><pre><span></span>vi ~/.gnupg/gpg-agent.conf

default-cache-ttl 34560000
max-cache-ttl 34560000
</pre></div>
                
                  
                
              
              
                
              
            </article>
          </div>
        </div>
      </main>
      
        
<footer class="md-footer">
  
    <div class="md-footer-nav">
      <nav class="md-footer-nav__inner md-grid">
        
          <a href="../Docker/" title="Docker" class="md-flex md-footer-nav__link md-footer-nav__link--prev" rel="prev">
            <div class="md-flex__cell md-flex__cell--shrink">
              <i class="md-icon md-icon--arrow-back md-footer-nav__button"></i>
            </div>
            <div class="md-flex__cell md-flex__cell--stretch md-footer-nav__title">
              <span class="md-flex__ellipsis">
                <span class="md-footer-nav__direction">
                  Previous
                </span>
                Docker
              </span>
            </div>
          </a>
        
        
          <a href="../Jekyll/" title="Jekyll" class="md-flex md-footer-nav__link md-footer-nav__link--next" rel="next">
            <div class="md-flex__cell md-flex__cell--stretch md-footer-nav__title">
              <span class="md-flex__ellipsis">
                <span class="md-footer-nav__direction">
                  Next
                </span>
                Jekyll
              </span>
            </div>
            <div class="md-flex__cell md-flex__cell--shrink">
              <i class="md-icon md-icon--arrow-forward md-footer-nav__button"></i>
            </div>
          </a>
        
      </nav>
    </div>
  
  <div class="md-footer-meta md-typeset">
    <div class="md-footer-meta__inner md-grid">
      <div class="md-footer-copyright">
        
          <div class="md-footer-copyright__highlight">
            <a href=http://www.miitbeian.gov.cn/>浙ICP备15043819号-2</a>&nbsp;&nbsp;<a target=_blank href=http://www.beian.gov.cn/portal/registerSystemInfo?recordcode=33010602007826><img src="/assets/images/beian.png" height=14px>浙公网安备 33010602007826号</p></a>
          </div>
        
        powered by
        <a href="http://www.mkdocs.org">MkDocs</a>
        and
        <a href="https://squidfunk.github.io/mkdocs-material/">
          Material for MkDocs</a>
      </div>
      
        
  <div class="md-footer-social">
    
    <link rel="stylesheet" href="https://cdnjs.loli.net/ajax/libs/font-awesome/4.7.0/css/font-awesome.min.css">
    
      <a href="https://github.com/zjuchenyuan" class="md-footer-social__link fa fa-github-alt"></a>
    
      <a href="mailto: py3io.chenyuan@qiushi.ac.cn" class="md-footer-social__link fa fa-envelope"></a>
    
  </div>

      
    </div>
  </div>
</footer>
      
    </div>
    
      <script src="../assets/javascripts/application.f041762f.js"></script>
      
      <script>app.initialize({version:"0.17.2",url:{base:".."}})</script>
      
        <script src="../assets/js/instantclick.min.js"></script>
      
    
    
      
    
  </body>
</html>